#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* pole */
int* vytvorPole(int n);
void vypisPole(int *pole, int velikost);
void naplnPole(int *pole, int velikost);
void setridPole(int *pole, int velikost);

/* 2D */
void dealookujPamet(int **matice, int r);
int **alookujPamet(int r, int s);
void vypisMatici(int **matice, int r, int s);
void naplnMatici(int **matice, int r, int s);

int main(int argc, char** argv) {
    int n, *up, **matice, max;
    printf("Zadejte velikost pole: \n");
    scanf("%d", &n);

    /*
    up = vytvorPole(n);
    vypisPole(up, n);
    naplnPole(up, n);
    vypisPole(up, n);
    setridPole(up, n);
    vypisPole(up, n);
    free(up);
    up = NULL;
     */
    matice = alookujPamet(n, n);
    vypisMatici(matice, n, n);
    naplnMatici(matice, n, n);
    vypisMatici(matice, n, n);
    printf("%d \n", maxDiagonal(matice, n, &max));
    printf("%d \n", max);
    dealookujPamet(matice, n);


    return (EXIT_SUCCESS);
}

/* pole */
int* vytvorPole(int n) {
    int *up;
    if ((up = (int *) malloc(n * sizeof (*up))) == NULL) { /* zadost o prideleni pameti */
        printf("Nedostatek pameti.\n");
    }
    return up;
}

void vypisPole(int *pole, int velikost) {
    int i;
    for (i = 0; i < velikost; i++) {
        printf("%d ", *(pole + i));
    }
    printf("\n");
}

void naplnPole(int *pole, int velikost) {
    int i;
    srand((unsigned) time(NULL));
    for (i = 0; i < velikost; i++) {
        *(pole + i) = (rand() % 100);
    }
}

void setridPole(int *pole, int velikost) {
    int *zacatek, *konec;
    int pomocna;
    zacatek = pole;
    konec = (pole + velikost - 1);
    while (zacatek < konec) {
        while ((*zacatek) % 2 == 0) {
            zacatek++;
        }
        while ((*konec) % 2 == 1) {
            konec--;
        }
        if (zacatek < konec) {
            pomocna = (*zacatek);
            *zacatek = *konec;
            *konec = pomocna;
        }
    }

    /*
     int indexZ = 0, indexK = n - 1;

    while (indexK > indexZ) {
        if (pole[indexZ] % 2 == 0) indexZ++;
        else if (pole[indexK] % 2 == 1) indexK--;
        else prohod(&pole[indexZ++], &pole[indexK--]);
    }

     */

}

/* dvojrozmerne */
void dealookujPamet(int **matice, int r) {
    int i;
    for (i = 0; i < r; i++) {
        free(matice[i]);
    }
    free(matice);
}

int **alookujPamet(int r, int s) {
    int **matice;
    int i;

    matice = (int **) malloc(r * sizeof (*matice));
    if (matice == NULL) {
        printf("Nedostatek pameti.");
        return NULL;
    }

    for (i = 0; i < r; i++) {
        matice[i] = (int *) malloc(s * sizeof (*matice[i]));
        if (matice[i] == NULL) {
            printf("Nedostatek pameti.");
            /* dealokace drive alokovaneho prostoru */
            dealookujPamet(matice, i);
            return NULL;
        }
    }
    return matice;
}

void naplnMatici(int **matice, int r, int s) {
    int i, j;
    srand((unsigned) time(NULL));
    for (i = 0; i < r; i++) {
        for (j = 0; j < s; j++) {
            matice[i][j] = rand() % 100;
            /*printf("%d", *(*(matice + i) + j));*/
        }
    }
}

void vypisMatici(int **matice, int r, int s) {
    int i, j;
    for (i = 0; i < r; i++) {
        for (j = 0; j < s; j++) {
            printf("%3d", matice[i][j]);
            /*printf("%3d", *(*(matice + i) + j));*/
        }
        printf("\n");
    }
}
